program RISCTERM;

Uses
  Crt, Dos, CommPak, Strings, ScrUnit, Mouse, Globals;

procedure HandleMouse;
var
   Loop : byte;
   BPressed : boolean;
   cBaud : byte;
   MX, huh : Byte;
   whichWay : integer;
begin
   BPressed := LeftButton or RightButton;
{   if not BPressed then Exit;}
   whichWay := 1;
   if RightButton then whichWay := -1;
   MX := MouseX div 8;

   case MX of
     2..8   : CurFunction := 1;
     10..16 : CurFunction := 2;
     18..29 : CurFunction := 3;
     31..35 : CurFunction := 4;
     37     : CurFunction := 5;
     38     : CurFunction := 6;
     40..48 : CurFunction := 7;
     50..64 : CurFunction := 8;
     66..77 : CurFunction := 9;
     else CurFunction := 0;
   end;
   if BPressed then begin
      repeat until ((not LeftButton) and (not RightButton));
      case CurFunction of
         1 : begin
                SaveScr;
                GetBaseAddress;
                initialize(baudrate,$ff);
                SetInterrupt(IRQNum);
                DataReady := FALSE;
                port[BaseAddress+MODEM_CTRL] := SetReceive;
                huh := port[baseaddress];
                TextColor(White);
                TextBackground(Blue);
                RestoreScr;
                updateScr;
             end;
         2 : begin
                SaveScr;
                oldIntr := IRQNum;
                newIntr := AskForInterrupt(oldIntr);
                ChangeInterrupt(newIntr);
                TextColor(White);
                TextBackground(Blue);
                DataReady := FALSE;
                port[BaseAddress+MODEM_CTRL] := SetReceive;
                huh := port[baseaddress];
                RestoreScr;
                updateScr;
             end;
         3 : begin
                for Loop := 1 to NUMBAUD do
                   if baudrate = BaudArray[Loop] then begin
                      cBaud := Loop + whichWay;
                      Loop := NUMBAUD;
                   end;
                   if cBaud = NUMBAUD+1 then cBaud := 1;
                   if cBaud = 0 then cBaud := NUMBAUD;
                initialize(BaudArray[cBaud],$ff);
                DataReady := FALSE;
                port[BaseAddress+MODEM_CTRL] := SetReceive;
             end;
         4 : begin
                if ParityMode = Even7 then
                   initialize(baudrate,None8) else initialize(baudrate,Even7);
                DataReady := FALSE;
                port[BaseAddress+MODEM_CTRL] := SetReceive;
             end;
         5 : begin
                if Out1=0 then Out1:=1 else Out1:=0;
                WriteOUT;
                updateScr;
             end;
         6 : begin
                if Out2=0 then Out2:=1 else Out2:=0;
                WriteOUT;
                updateScr;
             end;
         7 : helpScr;
         8 : begin
               if (DebugMode) then
                 EnterDebug
               else
                 ClrScr;
             end;
         9 : ExitProg;
      end;
      HideCursor;
   end else
     if (CurFunction <> oldFunction) then begin
       updateScr;
       oldFunction := CurFunction;
     end;
end;

procedure HandleRXChar;
const
   times : word = 0;
   mychar : char = #0;
   tempStr : String = '';
begin
   DataReady := False;
   tempStr := RString;
   RString := '';
   for times := 1 to Length(tempStr) do begin
      mychar := tempStr[times];
      if (DebugMode) then
        WriteDebug(mychar);
      if (mychar = #13) then
         writeln
      else if (mychar = #8) then
         write(#8, ' ', #8)
      else if (mychar = #7) then begin
              Beeping := TRUE;
              Sound(500);
              beeplength := 0;
           end
      else begin textcolor(Yellow);write(mychar);end;
   end;
end;

procedure WriteU;
var
   timeout : word;
begin
  port[BaseAddress+MODEM_CTRL] := SetTransmit;  {set transmit RTS}

  timeout := TIMEOUTDELAY;

  repeat
     dec(timeout);
  until ( ( (port[BaseAddress+LINE_STAT] AND $20) <> 0) OR (timeout = 0));

  if (timeout = 0) then
     WriteLn('Hardware transmission failure #1!');

  port[BaseAddress+TRANSMIT] := ord('U');  {send it}
  write('U');

  timeout:=TIMEOUTDELAY;

  repeat
     dec(timeout);
  until ( ( (port[BaseAddress+LINE_STAT] AND $20) <> 0) OR (timeout = 0)  );{wait until sent}


  if (timeout = 0) then
     WriteLn('Hardware transmission failure #2!');

  timeout := TIMEOUTDELAY;

  repeat
     dec(timeout);
  until ( ( (port[BaseAddress+LINE_STAT] AND $40) <> 0) OR (timeout = 0)  );{wait until sent}

  if (timeout = 0) then
     WriteLn('Hardware transmission failure #3!');

  port[BaseAddress+MODEM_CTRL] := SetReceive;  {set receive RTS}

end;

procedure HandleUserChar;
var
   huh : byte;
   first, extended : char;
   timeout : word;
begin
   first := readkey;
   if (first <> #0) then begin

     port[BaseAddress+MODEM_CTRL] := SetTransmit;  {set transmit RTS}

     timeout := TIMEOUTDELAY;

     repeat
        dec(timeout);
     until ( ( (port[BaseAddress+LINE_STAT] AND $20) <> 0) OR (timeout = 0));

     if (timeout = 0) then
        WriteLn('Hardware transmission failure #1!');

     port[BaseAddress+TRANSMIT] := ord(first);  {send it}

     if (first = #13) then
        writeln
     else if (first = #8) then
        write(#8, ' ',#8)
     else begin TextColor(GReen);write(first);end;

     timeout:=TIMEOUTDELAY;

     repeat
        dec(timeout);
     until ( ( (port[BaseAddress+LINE_STAT] AND $20) <> 0) OR (timeout = 0)  );{wait until sent}


     if (timeout = 0) then
        WriteLn('Hardware transmission failure #2!');

     timeout := TIMEOUTDELAY;

     repeat
        dec(timeout);
     until ( ( (port[BaseAddress+LINE_STAT] AND $40) <> 0) OR (timeout = 0)  );{wait until sent}

     if (timeout = 0) then
        WriteLn('Hardware transmission failure #3!');

     port[BaseAddress+MODEM_CTRL] := SetReceive;  {set receive RTS}

   end else begin

     extended := readkey;
     case extended of
        #23 : begin
                SaveScr;
                oldIntr := IRQNum;
                newIntr := AskForInterrupt(oldIntr);
                ChangeInterrupt(newIntr);
                huh := port[baseaddress];
                TextColor(White);
                TextBackground(Blue);
                RestoreScr;
                updateScr;
              end;
        #32 : begin
                DebugMode := NOT DebugMode;
                if (DebugMode) then
                  EnterDebug
                else
                  ExitDebug;
              end;
        #45 : DoExit := TRUE;
        #46 : begin
               if (DebugMode) then
                 EnterDebug
               else
                 ClrScr;
                 huh := port[baseaddress];
              end;
        #48 : begin
                 SaveScr;
                 GetBaseAddress;
                 initialize(baudrate,$ff);
                 ChangeInterrupt(IRQNum);
                 huh := port[baseaddress];
                 TextColor(White);
                 TextBackground(Blue);
                 RestoreScr;
                 updateScr;
              end;
        #59 : HelpScr;
        #61 : initialize(2400,$ff);
        #62 : initialize(4800,$ff);
        #63 : initialize(9600,$ff);
        #64 : initialize(14400,$ff);
        #65 : initialize(19200,$ff);
        #66 : initialize(28800,$ff);
        #67 : initialize(57600,$ff);
        #68 : initialize(38400,$ff);
        #60 : initialize(0,$ff);
        #22 : repeat
                WriteU;
              until keypressed;

        #$78 : begin
                 if Out1=0 then Out1:=1 else Out1:=0;
                 WriteOUT;
                 updateScr;
               end;
        #$79 : begin
                 if Out2=0 then Out2:=1 else Out2:=0;
                 WriteOUT;
                 updateScr;
               end;
        #$7E : initialize(baudrate,Even7);
        #$7F : initialize(baudrate,None8);
     end
   end
end;

procedure mainprogram;
var
   huh : byte;
begin
   beeplength := 0;
   Beeping := FALSE;
   port[BaseAddress+MODEM_CTRL] := SetReceive;

   repeat
     repeat
        if (Polling) then
          CheckForData;
        if (FoundMouse) then handleMouse;
        if Beeping then
          if (beeplength >= 2500) then begin
             NoSound;
             Beeping := False;
          end else inc(beeplength);
     until (keypressed or DataReady);

     if DataReady then
        HandleRXChar
     else
        HandleUserChar;

   until DoExit;
end;

procedure doMouse;
begin
   Write('Searching for mouse . . .');
   FoundMouse := False;
   ResetMouse(FoundMouse);
   if (FoundMouse) then writeln('found') else writeln('not found.');
   MoveMouseCursor(0 * 8, height * 8);
   SetMouseWindow(0, (height-1) * 8, 79 * 8, (height-1) * 8);
end;

procedure SetDefaults;
begin
   height := hi(windmax)+1;
   if not BaseSet then GetBaseAddress;
   if not IRQSet then IRQNum := AskForInterrupt(0);
   if not ParitySet then begin
      ParityMode := Even7;
      ParityModeStr := '7E1';
   end;
   if not BaudSet then Initialize(9600,$ff)
      else Initialize(baudrate,$ff);
   SetInterrupt(IRQNum);
   Out1 := 1;
   Out2 := 1;
   RString := '';
   updateScr;
   DebugMode := False;
   CheckSnow := FALSE;
   DirectVideo := TRUE;
   DoExit := FALSE;
end;

procedure ParseCommandLine;
var
   paramNum, pCount, Loop : byte;
   pStr, tStr : string;
   bVal : word;
   eCode : integer;
begin
   BaseSet := FALSE;
   BaudSet := FALSE;
   IRQSet := FALSE;
   ParitySet := FALSE;

   pCount := ParamCount;
   for paramNum := 1 to pCount do begin
      pStr := ParamStr(paramNum);
      case upCase(pStr[2]) of
         'P' : begin
                  if CapStr(RtStr(pStr,3)) = '7E1' then begin
                     ParityMode := Even7;
                     ParityModeStr := '7E1';
                     ParitySet := TRUE;
                  end;
                  if CapStr(RtStr(pStr,3)) = '8N1' then begin
                     ParityMode := None8;
                     ParityModeStr := '8N1';
                     ParitySet := TRUE;
                  end;
               end;
         'A' : begin
                  tStr := copy(pStr,3,4);
                  bVal := Deci(tStr);
                  if (bVal >= $00)  then begin
                     BaseSet := TRUE;
                     BaseAddress := bVal;
                  end;
               end;
         'B' : begin
                  tStr := copy(pStr,3,length(pStr));
                  Val(tStr,bVal,eCode);
                  for Loop := 1 to NUMBAUD do
                     if bVal = BaudArray[Loop] then begin
                        BaudSet := TRUE;
                        baudrate := bVal;
                     end;
               end;
         'I' : begin
                  tStr := '$' + copy(pStr,3,1);
                  Val(tStr,bVal,eCode);
                  if (((bVal <= 15) AND (bVal >= 2)) OR (bVal = 0)) then begin
                     IRQNum := bVal;
                     IRQSet := TRUE;
                  end;
               end;
      end;
   end;
end;

Begin
   doMouse;
   ParseCommandLine;
   SetDefaults;
   ClrScr;
   updateScr;
   MainProgram;
   ExitProg;
End.
