
unit strings;

INTERFACE

    function AskForBaseAddress(OldOne : Word) : Word;
    Function AskForInterrupt(OldOne : byte) : byte;
    function HexVal(swork : string) : longint;
    function HexAscii(value : longint; n : byte) : string;
    function MidStr(StWork : String; Place1, Place2 : Byte) : String;
    function LtStr(StWork : String; Place : Byte) : String;
    function RtStr(StWork : String; Place : Byte) : String;
    function CapStr(StWork : string) : string;
    function Deci(DS : String) : Word;
    function Hex(BB : Word) : String;

const
   hextab:array[0..15] of char = '0123456789ABCDEF';
   nibble = $F;

var
   height : byte;

implementation

uses Crt,ics;

    function HexVal(swork : string) : longint;
    var
      returnVal : longint;
      errorV : integer;
    begin
      swork := '$' + swork;
      val(swork, returnVal, errorV);
      HexVal := returnVal;
    end;

    function HexAscii(value : longint; n:byte) : string;
    var
        hexstr : string[8];
        mask   : longint;
    begin
      if (n > 8) then n := 8;
      hexstr := '0';
      if n = 0 then begin
        mask := $F0000000;
        n := 8;
        while ((value and mask) = 0)  and (n > 0) do begin
          mask := mask shr 4;
          dec(n);
        end;
      end;
      if n > 0 then begin
        hexstr[0] := chr(n);
        while n > 0 do begin
          hexstr[n] := hextab[(value and nibble)];
          value := value shr 4;
          dec(n);
        end;
      end;
      hexAscii := hexstr;
    end;


Function MidStr(StWork : String; Place1, Place2 : Byte) : String;
Var
  Place, Loop : Byte;
Begin
  Place := Place1 - 1;
  Loop := 0;
  Repeat
     Inc(Loop); Inc(Place);
     StWork[Loop] := StWork[Place];
  Until Place = Place2;
  StWork[0] := Chr(Place2 - Place1 + 1);
  MidStr := StWork;
End;

Function LtStr(StWork : String; Place : Byte) : String;
Begin
 Dec(StWork[0], Length(StWork) - Place);
 LtStr := StWork;
End;

Function RtStr(StWork : String; Place : Byte) : String;
Var
 Times, Len, Hold : Byte;
 Dummy : String;
Begin
 Dummy := '';
 Hold := 0;
 Len := Length(StWork);
 For Times := (Len - Place + 1) To Len Do
  Begin
   Inc(Dummy[0]);
   Inc(Hold);
   Dummy[Hold] := StWork[Times];
  End;
 RtStr := Dummy;
End;

Function CapStr(StWork : String) : String;
Var
 Times, Len : Byte;
 Dummy : String;
Begin
 Dummy := StWork;
 Len := Length(StWork);
 For Times := 1 To Len Do
    Dummy[Times] := UpCase(StWork[Times]);
 CapStr := Dummy;
End;

Function Deci(DS : String) : Word;
Var
 BS : String;
 Er : Integer;
 DI : Word;
Begin
 BS := '$' + DS;
 Val(BS, DI, Er);
 Deci := DI;
End;

Function Hex(BB : Word) : String;
Var
 AA, CC : Byte;
 DD : String;
 HexTable : String;
Begin
 HexTable := '0123456789ABCDEF';
 DD := '000';
 DD[3] := HexTable[(BB AND $00F) + 1];
 DD[2] := HexTable[((BB AND $0F0) SHR 4) + 1];
 DD[1] := HexTable[((BB AND $F00) SHR 8) + 1];
 Hex := DD;
End;

procedure getStr(var wStr : string; num : byte);
const
   HexDigits = ['0'..'9','A'..'F'];
var
   cur : byte;
   charTyped : char;
   newStr : string;
begin
  newStr[0] := char(num);
  for cur := 1 to num do newStr[cur] := #32;
  for cur := 1 to (num + 1) do begin
     dec(cur);
     charTyped := UpCase(ReadKey);
     if (charTyped = #27) then Exit;
     if ((charTyped = #13) AND (cur = num)) then begin
        wStr := newStr;
        Exit;
     end;
     if ((charTyped = #13) AND (cur = 3)) then begin {fix for pci boards}
        newStr[0] := #3;
        wStr := newStr;
        Exit;
     end;
     if ((charTyped = #13) AND (cur = 0)) then Exit;
     if ((charTyped IN HexDigits) AND (cur < num)) then begin
        newStr[cur+1] := charTyped;
        write(charTyped);
        inc(cur);
     end;
     if ((charTyped = #8) AND (cur >= 1)) then begin
        write(#8, ' ', #8);
        dec(cur);
     end;
  end;
end;

Function AskForBaseAddress(OldOne : Word) : Word;
Var
   Msg : String;
   NewOne : Word;
Begin
   TextColor(LightGray);
   TextBackground(Black);
   ClrScr;
   writeln(identstr);
   Window(5, 5, 75, height-5);
   TextColor(WHITE);
   TextBackGround(BLUE);
   ClrScr;
   Window(10, 7, 70, 17);
   WriteLn;
   WriteLn;
   WriteLn;
   WriteLn('Please enter the Base Address for your card (in hex) between');
   WriteLn('0000H and FFFFH, or press ENTER for ', Hex(OldOne), '.');
   Write('>');
   msg := Hex(OldOne);
   getStr(msg, 4);
   NewOne := Deci(msg);
   TextColor(LIGHTGRAY);
   TextBackGround(BLACK);
   Window(1, 1, 80, height-1);
   ClrScr;
   AskForBaseAddress := OldOne;
   If (NewOne >= $00) Then AskForBaseAddress := NewOne
      else write(#7);
End;

Function AskForInterrupt(OldOne : byte) : byte;
Var
   Msg : String;
   NewOne : Word;
Begin
   TextColor(LightGray);
   TextBackground(Black);
   ClrScr;
   writeln(identstr);
   Window(5, 5, 75, height-5);
   TextColor(WHITE);
   TextBackGround(BLUE);
   ClrScr;
   Window(10, 7, 70, 17);
   WriteLn;
   WriteLn;
   WriteLn;
   WriteLn('Please enter the interrupt for your card (in hex) between');
   WriteLn('2 and F, or press ENTER for ', OldOne, '.  Enter 0 for polling mode.');
   Write('>');
   msg := Hex(OldOne);
   getStr(msg, 1);
   NewOne := Deci(msg);
   TextColor(LIGHTGRAY);
   TextBackGround(BLACK);
   Window(1, 1, 80, height-1);
   ClrScr;
   AskForInterrupt := OldOne;
   if (((NewOne >= 2) AND (NewOne <= 15)) OR (NewOne = 0)) Then AskForInterrupt := NewOne
      else write(#7);
End;

end.
